Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.xml.parsers
Class DocumentBuilder

    java.lang.Object
      |
      +--javax.xml.parsers.DocumentBuilder

public abstract class DocumentBuilder
extends Object

Defines the API to obtain DOM Document instances from an XML document. Using this class, an application programmer can obtain a `Document` from XML.

An instance of this class can be obtained from the `DocumentBuilderFactory.newDocumentBuilder` method. Once an instance of this class is obtained, XML can be parsed from a variety of input sources. These input sources are InputStreams, Files, URLs, and SAX InputSources.

Note that this class reuses several classes from the SAX API. This does not require that the implementor of the underlying DOM implementation use a SAX parser to parse XML document into a `Document`. It merely requires that the implementation communicate with the application using these existing APIs.

An implementation of `DocumentBuilder` is NOT guaranteed to behave as per the specification if it is used concurrently by two or more threads. It is recommended to have one instance of the `DocumentBuilder` per thread or it is upto the application to make sure about the use of `DocumentBuilder` from more than one thread.

Since:
  JAXP 1.0

Constructor Summary
`protected` | `DocumentBuilder()`

Method Summary
`abstract DOMImplementation` | `getDOMImplementation()` Obtain an instance of a `DOMImplementation` object.
`abstract boolean` | `isNamespaceAware()` Indicates whether or not this parser is configured to understand namespaces.
`abstract boolean` | `isValidating()` Indicates whether or not this parser is configured to validate XML documents.
`abstract Document` | `newDocument()` Obtain a new instance of a DOM `Document` object to build a DOM tree with.
`Document` | `parse(File f)` Parse the content of the given file as an XML document and return a new DOM `Document` object.
`abstract Document` | `parse(InputSource is)` Parse the content of the given input source as an XML document and return a new DOM `Document` object.
`Document` | `parse(InputStream is)` Parse the content of the given `InputStream` as an XML document and return a new DOM `Document` object.
`Document` | `parse(InputStream is, String systemId)` Parse the content of the given `InputStream` as an XML document and return a new DOM `Document` object.
`Document` | `parse(String uri)` Parse the content of the given URI as an XML document and return a new DOM `Document` object.
`abstract void` | `setEntityResolver(EntityResolver er)` Specify the `EntityResolver` to be used to resolve entities present in the XML document to be parsed.
`abstract void` | `setErrorHandler(ErrorHandler eh)` Specify the `ErrorHandler` to be used to report errors present in the XML document to be parsed.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DocumentBuilder

    protected DocumentBuilder()

Method Detail

### parse

    public Document parse(InputStream is)
                   throws SAXException,
                          IOException

  Parse the content of the given `InputStream` as an XML document and return a new DOM `Document` object.

  Parameters:
    `is` - InputStream containing the content to be parsed.
  Throws:
    `IOException` - If any IO errors occur.
    `SAXException` - If any parse errors occur.
    `IllegalArgumentException` - If the InputStream is null
  See Also:
    `DocumentHandler`

### parse

    public Document parse(InputStream is,
                          String systemId)
                   throws SAXException,
                          IOException

  Parse the content of the given `InputStream` as an XML document and return a new DOM `Document` object.

  Parameters:
    `is` - InputStream containing the content to be parsed.
    `systemId` - Provide a base for resolving relative URIs.
  Returns:
    A new DOM Document object.
  Throws:
    `IOException` - If any IO errors occur.
    `SAXException` - If any parse errors occur.
    `IllegalArgumentException` - If the InputStream is null.
  See Also:
    `DocumentHandler`

### parse

    public Document parse(String uri)
                   throws SAXException,
                          IOException

  Parse the content of the given URI as an XML document and return a new DOM `Document` object.

  Parameters:
    `uri` - The location of the content to be parsed.
  Returns:
    A new DOM Document object.
  Throws:
    `IOException` - If any IO errors occur.
    `SAXException` - If any parse errors occur.
    `IllegalArgumentException` - If the URI is null.
  See Also:
    `DocumentHandler`

### parse

    public Document parse(File f)
                   throws SAXException,
                          IOException

  Parse the content of the given file as an XML document and return a new DOM `Document` object.

  Parameters:
    `f` - The file containing the XML to parse.
  Returns:
    A new DOM Document object.
  Throws:
    `IOException` - If any IO errors occur.
    `SAXException` - If any parse errors occur.
    `IllegalArgumentException` - If the file is null.
  See Also:
    `DocumentHandler`

### parse

    public abstract Document parse(InputSource is)
                            throws SAXException,
                                   IOException

  Parse the content of the given input source as an XML document and return a new DOM `Document` object.

  Parameters:
    `is` - InputSource containing the content to be parsed.
  Returns:
    A new DOM Document object.
  Throws:
    `IOException` - If any IO errors occur.
    `SAXException` - If any parse errors occur.
    `IllegalArgumentException` - If the InputSource is null.
  See Also:
    `DocumentHandler`

### isNamespaceAware

    public abstract boolean isNamespaceAware()

  Indicates whether or not this parser is configured to understand namespaces.

  Returns:
    true if this parser is configured to understand namespaces; false otherwise.

### isValidating

    public abstract boolean isValidating()

  Indicates whether or not this parser is configured to validate XML documents.

  Returns:
    true if this parser is configured to validate XML documents; false otherwise.

### setEntityResolver

    public abstract void setEntityResolver(EntityResolver er)

  Specify the `EntityResolver` to be used to resolve entities present in the XML document to be parsed. Setting this to `null` will result in the underlying implementation using it's own default implementation and behavior.

  Parameters:
    `er` - The `EntityResolver` to be used to resolve entities present in the XML document to be parsed.

### setErrorHandler

    public abstract void setErrorHandler(ErrorHandler eh)

  Specify the `ErrorHandler` to be used to report errors present in the XML document to be parsed. Setting this to `null` will result in the underlying implementation using it's own default implementation and behavior.

  Parameters:
    `eh` - The `ErrorHandler` to be used to report errors present in the XML document to be parsed.

### newDocument

    public abstract Document newDocument()

  Obtain a new instance of a DOM `Document` object to build a DOM tree with. An alternative way to create a DOM Document object is to use the `getDOMImplementation` method to get a DOM Level 2 DOMImplementation object and then use DOM Level 2 methods on that object to create a DOM Document object.

  Returns:
    A new instance of a DOM Document object.

### getDOMImplementation

    public abstract DOMImplementation getDOMImplementation()

  Obtain an instance of a `DOMImplementation` object.

  Returns:
    A new instance of a `DOMImplementation`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.